#[repr(C)]
#[derive(Copy, Clone, Debug, bytemuck::Pod, bytemuck::Zeroable)]
pub struct Vertex {
    pub position: [f32; 3],
    pub tex_coords: [f32; 2],
}

impl Vertex {

  const ATTRIBS: [wgpu::VertexAttribute; 2] =
        wgpu::vertex_attr_array![0 => Float32x3, 1 => Float32x2];

  pub fn desc<'a>() -> wgpu::VertexBufferLayout<'a> {
      use std::mem;

      wgpu::VertexBufferLayout {
          array_stride: mem::size_of::<Self>() as wgpu::BufferAddress,
          step_mode: wgpu::VertexStepMode::Vertex,
          attributes: &Self::ATTRIBS,
      }
  }

  // pub fn desc<'a>() -> wgpu::VertexBufferLayout<'a> {
  //     wgpu::VertexBufferLayout {
  //         array_stride: std::mem::size_of::<Vertex>() as wgpu::BufferAddress,
  //         step_mode: wgpu::VertexStepMode::Vertex,
  //         attributes: &[
  //             wgpu::VertexAttribute {
  //                 offset: 0,
  //                 shader_location: 0,
  //                 format: wgpu::VertexFormat::Float32x3,
  //             },
  //             wgpu::VertexAttribute {
  //                 offset: std::mem::size_of::<[f32; 3]>() as wgpu::BufferAddress,
  //                 shader_location: 1,
  //                 format: wgpu::VertexFormat::Float32x2,
  //             }
  //         ]
  //     }
  // }
}